"{ Package: 'stx:goodies/ring/core' }"

"{ NameSpace: Smalltalk }"

RGBehaviorFactory subclass:#RGTrait
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Ring-Core-Kernel'
!

RGTrait comment:'A factory that produces instances of RGBehavior composed with RGTraitStrategy'
!

!RGTrait class methodsFor:'instance creation'!

newStrategy

    ^ RGTraitStrategy basicNew
!

newStrategyFor: anRGEnvironment

    ^ (self strategyClassForVersion: anRGEnvironment version) basicNew
!

strategyClassForVersion: aVersionNumber

    ^ (aVersionNumber <= 6)
        ifTrue: [ RGTraitStrategy ]
        ifFalse: [ RGTraitV2Strategy ]
! !

